/*
 Copyright 2024 PostalPortal LLC, Netsyms Technologies LLC. All rights reserved.
 */

var rates = [];
setInterval(function () {
    document.getElementById("statuslogo").classList.remove("display-none");
    if (typeof global.weightStr == "string" && global.weightStr != "") {
        document.getElementById("statusbar").classList.add("display-flex");
        document.getElementById("statusbar").classList.remove("display-none");
        document.getElementById("scaledisplay").innerHTML = global.weightStr;
    } else {
        document.getElementById("statusbar").classList.add("display-none");
        document.getElementById("statusbar").classList.add("display-flex");
        document.getElementById("scaledisplay").innerHTML = "";
    }
    if (!receiptEmpty()) {
        document.getElementById("receiptscreen").classList.remove("display-none");
        document.getElementById("receiptscreen").classList.add("display-flex");
        document.getElementById("welcomescreen").classList.remove("display-flex");
        document.getElementById("welcomescreen").classList.add("display-none");
        var items = receiptToHTML(["items"]);
        document.getElementById("receiptitems").innerHTML = items;
        document.getElementById("receiptitemscontainer").scrollTop = document.getElementById("receiptitemscontainer").offsetHeight;
        var payments = receiptToHTML(["total", "payments"]);
        document.getElementById("receiptpayments").innerHTML = payments;
        document.getElementById("receiptpaymentscontainer").scrollTop = document.getElementById("receiptpaymentscontainer").offsetHeight;
    } else {
        document.getElementById("receiptscreen").classList.add("display-none");
        document.getElementById("receiptscreen").classList.remove("display-flex");
        document.getElementById("welcomescreen").classList.add("display-flex");
        document.getElementById("welcomescreen").classList.remove("display-none");
        document.getElementById("statuslogo").classList.add("display-none");
    }
}, 1000);

function receiptEmpty() {
    var rec = global.receipt;
    if (rec.grandTotal == 0 && rec.items.length == 0 && rec.payments.length == 0) {
        return true;
    }
    return false;
}

function receiptToHTML(show) {
    var html = "";

    var receipt = global.receipt;

    if (typeof show == "undefined") {
        show = true;
    }

    //
    // Receipt items
    //
    if (show == true || show.includes("items")) {
        for (let i = 0; i < receipt.items.length; i++) {
            let item = receipt.items[i];
            if (item.free) {
                html += "<div><b>" + item.label + "</b></div>";
            } else {
                if (item.qty > 1) {
                    html += `<div style="display: flex; justify-content: space-between;"><div><b>${item.label}</b></div> <div>${item.qty} @ ${item.priceEachFormatted}: ${item.linePriceFormatted}</div></div>`;
                } else {
                    html += `<div style="display: flex; justify-content: space-between;"><div><b>${item.label}</b></div> <div>${item.qty} @ ${item.linePriceFormatted}</div></div>`;
                }
            }

            if (item.text) {
                for (let j = 0; j < item.text.split("\n").length; j++) {
                    html += "<div style=\"margin-left: 10px;\">" + item.text.split("\n")[j] + "</div>";
                }
            }
            if (i != receipt.items.length - 1) {
                html += "<hr />";
            }
        }
        html += "<br />";
        html += "<br />";
    }

    if (show == true || show.includes("total")) {
        if (receipt.tax > 0) {
            html += `<div style="display: flex; justify-content: space-between;"><div>Subtotal</div> <div>${receipt.subtotalFormatted}</div></div>`;
            html += `<div style="display: flex; justify-content: space-between;"><div>Tax</div> <div>${receipt.taxFormatted}</div></div>`;
        }
        //printer.setTextDoubleHeight();
        html += `<div style="display: flex; justify-content: space-between;"><div><b>Total</b></div> <div><b>${receipt.grandTotalFormatted}</b></div></div>`;

        html += "<hr />";
    }

    //
    // Receipt payments
    //
    if (show == true || show.includes("payments")) {
        for (let i = 0; i < receipt.payments.length; i++) {
            let item = receipt.payments[i];
            html += `<div style="display: flex; justify-content: space-between;"><div><b>${item.label}</b></div> <div>${item.amountFormatted}</div></div>`;

            if (item.text) {
                for (let j = 0; j < item.text.split("\n").length; j++) {
                    html += "<div style=\"margin-left: 10px;\">" + item.text.split("\n")[j] + "</div>";
                }
            }
        }

        if (receipt.payments.length > 0) {
            html += "<hr />";
        }
        if (receipt.paid > 0) {
            html += `<div style="display: flex; justify-content: space-between;"><div><b>Paid</b></div> <div><b>${receipt.paidFormatted}</b></div></div>`;
        }
        if (receipt.due > 0) {
            html += `<div style="display: flex; justify-content: space-between;"><div><b>Amount Owed</b></div> <div><b>${receipt.dueFormatted}</b></div></div>`;
        } else if (receipt.due <= 0 && receipt.paid > 0) {
            html += `<div style="display: flex; justify-content: space-between;"><div><b>Change</b></div> <div><b>${receipt.dueFormatted}</b></div></div>`;
        }
    }

    return html;
}
